#include<bits/stdc++.h>

using namespace std;

int n,k;
stack<int> pomoc;
int pom;
vector<int> ispis;
int koliko;

int main()
{
    ios_base::sync_with_stdio(false);
    cin >> n >> k;
    for(int i=0;i<n;i++)
    {
        if(k==0)
        {
            cin >> pom;
            pomoc.push(pom);
        }
        else
        {
            if(!pomoc.empty())
            {
                cin >> pom;
                while(!pomoc.empty() && pomoc.top()>pom && k>0)
                    pomoc.pop(),k--;
                pomoc.push(pom);
            }
            else
            {
                cin >> pom;
                pomoc.push(pom);
            }
        }
    }
    koliko=pomoc.size();
    for(int i=0;i<koliko;i++)
    {
        ispis.push_back(pomoc.top());
        pomoc.pop();
    }
    for(int i=ispis.size()-1-k;i>=0;i--)
        cout << ispis[i] << " ";
}